import 'dart:io';
import 'dart:async';

import 'package:sqljocky/sqljocky.dart';
import 'package:logging/logging.dart';

final Duration duration = new Duration(hours: 0, minutes: 0, seconds: 40);
// 6 hours - ok
// 7 hours - ok
// 7 hours, 30 minutes - ok
// 8 hours triggers it
// 9 hours triggers it

String db_host = "localhost";
int db_port = 3306;
String db_user = "test";
String db_password = "test";
String db_name = "test";

final Logger log = new Logger('SQLjocky-SocketError-test');

ConnectionPool pool;

void do_a_query()
{
  log.info("do_a_query");

  pool.prepare("SELECT * from test1").then((Query query) {

    query.execute([]).then((Results results) {

      var num_rows = 0;

      results.forEach((Row row) {
        var givenName = row[0];
        num_rows++;

      }).then((_) {
        log.info("success (${num_rows} rows)");
        var f = new Future.delayed(duration).then((_) { do_a_query(); });

      })
      .catchError((e) { log.severe("test: forEach: $e"); });
    })
    .catchError((e) { log.severe("test: execute: $e"); });
  })
  .catchError((e) { log.severe("test: prepare: $e"); });
}

//----------------------------------------------------------------

void main(List<String> arguments) {
  Logger.root.level = Level.INFO; // Change to Level.ALL to see everything
  Logger.root.onRecord.listen((LogRecord rec) {
    print('${rec.time}: ${rec.level.name}: ${rec.message}');
  });

  log.info("Duration: ${duration}");

  pool = new ConnectionPool(host: db_host, port: db_port,
  user: db_user, password: db_password, db: db_name, max: 5);
  if (pool == null) {
    print("Error: could not create connection pool to database");
    exit(1);
  }

  do_a_query();
}